//
//  QHVCNetEnumerates.h
//  QHVCNetKit
//
//  Created by yangkui on 2019/8/5.
//  Copyright © 2019 yangkui. All rights reserved.
//

#ifndef QHVCNetEnumerates_h
#define QHVCNetEnumerates_h

#import <Foundation/Foundation.h>

/**
 SDK错误码
 */
typedef NS_ENUM(NSInteger, QHVCNetErrorCode) {
    QHVCNetErrorCodeNoError = 0,//无错误
    QHVCNetErrorCodeFailed = 1,//一般错误，原因未分类
    QHVCNetErrorCodeInvalidArgument = 2,//无效的参数
    QHVCNetErrorCodeSignallingModelError = 3,//信令通道模式使用错误

    QHVCNetErrorCodeUninitOnAppStart = 100,
    QHVCNetErrorCodeRepeatInitAppStart,
    QHVCNetErrorCodeUninit,
    QHVCNetErrorCodeRepeatInit,
    QHVCNetErrorCodeEventCallbackIsEmpty,
    QHVCNetErrorCodeLongConnectCallbackIsEmpty = 105,
    QHVCNetErrorCodeInputBufferSizeTooSmaller,
    QHVCNetErrorCodeLocalSercerListenAddressInvalid,
    QHVCNetErrorCodeSessionIsEmpty,
    QHVCNetErrorCodeSessionIsUsed,
    QHVCNetErrorCodeSessionInvalid = 110,
    QHVCNetErrorCodeTokenTooLong,
    QHVCNetErrorCodeFileKeyIsEmpty,
    QHVCNetErrorCodeFileDownloadRangeNoLegal,
    QHVCNetErrorCodeDownloadFileOpenFileFailed,
    QHVCNetErrorCodeDownloadFileGetAbsFilePathFailed = 115,
    QHVCNetErrorCodeDownloadFileRepeatDownloadSameFileKey,
    QHVCNetErrorCodeRecordRangeNoLegal,
    QHVCNetErrorCodeRecordPlaySpeedNoLegal,
    QHVCNetErrorCodeP2PPunchHoleFailed,
    QHVCNetErrorCodeDirectIPConnectFailed = 120,
    QHVCNetErrorCodeDisableAllConnectType,
    QHVCNetErrorCodeNoFoundDecryptKey,
    QHVCNetErrorCodeNoSupportedDecryptAlgo,
    QHVCNetErrorCodeVerifyTokenFailed,
    QHVCNetErrorCodeWaitTokenTimeoutInP2P = 125,
    QHVCNetErrorCodeWaitTimelineResTimeoutInP2P,
    QHVCNetErrorCodeWaitStreamConnectTimeoutInP2P,
    QHVCNetErrorCodeStreamConnectFailedInP2P,
    QHVCNetErrorCodeHeartBeatTimeoutInP2P,
    QHVCNetErrorCodeTooLongTimeNoReceivePeerDataInP2P = 130,
    QHVCNetErrorCodeStreamDisconnectInP2P,
    QHVCNetErrorCodeWaitLongConnnectConnectSucessTimeoutInRelay,
    QHVCNetErrorCodeWaitTokenTimeoutInRelay,
    QHVCNetErrorCodeWaitTimelineResTimeoutInRelay,
    QHVCNetErrorCodeHeartbeatTimeoutInRelay = 135,
    QHVCNetErrorCodeWaitStreamConnectTimeoutInRelay,
    QHVCNetErrorCodeCallScheuleFailedInRelay,
    QHVCNetErrorCodeScheduleCallbackFailedInRelay,
    QHVCNetErrorCodeStreamConnectFailedInRelay,
    QHVCNetErrorCodeTooLongTimeNoReceivePeerDataInRelay = 140,
    QHVCNetErrorCodeStreamDisConnectInRelay,
    QHVCNetErrorCodeWaitTokenTimeoutInDirectIP,
    QHVCNetErrorCodeWaitTimelineResTimeoutInDirectIP,
    QHVCNetErrorCodeWaitStreamConnenctTimeoutInDirectIP,
    QHVCNetErrorCodeStreamConnectFailedInDirectIP = 145,
    QHVCNetErrorCodeHeartbeatTimeoutInDirectIP,
    QHVCNetErrorCodeTooLongtimeNoReceivePeerDataInDirectIP,
    QHVCNetErrorCodeStreamDisconnectInDirectIP,
    QHVCNetErrorCodeRepeatCallGetRecordTimeline,
    QHVCNetErrorCodeFileDownloadTimeout = 150,
    QHVCNetErrorCodeDeviceCommandSending,
    QHVCNetErrorCodeDeviceCommandResponseTimeout,
    QHVCNetErrorCodeSaveRecordFileReadyDownload,
    QHVCNetErrorCodeSaveRecordFileUserStop,
    QHVCNetErrorCodeSaveRecordFileStopUserRequest = 155,
    QHVCNetErrorCodeSaveRecordFileNoRangeMediaData,
    QHVCNetErrorCodeWaitPubStreamTimeoutInRelay,
    QHVCNetErrorCodeNoFoundStorageDevice,
    QHVCNetErrorCodeNoSupportedRecordDelete,
    QHVCNetErrorCodeWaitTokenTimeoutInLongConnnectWhenRecvTokenAck = 160,
    
    //device
    QHVCNetErrorCodeDeviceUninitOnAppStart = 500,
    QHVCNetErrorCodeDeviceRepeatInitOnAppStart,
    QHVCNetErrorCodeDeviceUninit,
    QHVCNetErrorCodeDeviceRepeatInit,
    QHVCNetErrorCodeDeviceListenPortInvalid,
    QHVCNetErrorCodeDeviceEventCBIsEmpty = 505,
    QHVCNetErrorCodeDeviceRelayCBIsEmpty,
    QHVCNetErrorCodeDeviceAudioCBIsEmpty,
    QHVCNetErrorCodeNoSupportedEncryptAlgo,
    QHVCNetErrorCodeEncryptKeyInvalid,
    QHVCNetErrorCodeNoSupportedRecordPlayStrategy = 510,
    QHVCNetErrorCodeNoSupportedAudioFormat,
    QHVCNetErrorCodeMediaAudioFrameAACTooLong,
    QHVCNetErrorCodeAudioParamIsEmpty,
    QHVCNetErrorCodeNoSupportedAudioSampleRate,
    QHVCNetErrorCodeNoSupportedAudioSampleDepth = 515,
    QHVCNetErrorCodeNoSupportedAudioChannelConfig,
    QHVCNetErrorCodeNoSupportedVideoEncoder,
    QHVCNetErrorCodeNoSupportedFrameType,
    QHVCNetErrorCodeMediaFrameDataIsEmpty,
    QHVCNetErrorCodeMediaFrameLengthTooSamll = 520,
    QHVCNetErrorCodeMediaVideoFrameDataNonAnnixB,
    QHVCNetErrorCodeMediaVideoKeyFrameDataNoFoundIIn264,
    QHVCNetErrorCodeMediaVideoKeyFrameDataNoFoundIIn265,
    QHVCNetErrorCodeMediaVideoFrameDataOfMainBitrateTooLong,
    QHVCNetErrorCodeMediaVideoFrameDataOfSubBitrateTooLong = 525,
    QHVCNetErrorCodeMediaVideoFrameDataOfThirdBitrateTooLong,
    QHVCNetErrorCodeMediaVideoExtendDataIsEmpty,
    QHVCNetErrorCodeMediaVideoExtendDataNoLegal,
    QHVCNetErrorCodeMediaVideoExtendDataTooLong,
    QHVCNetErrorCodeEntendDataInNonVideoData = 530,
    QHVCNetErrorCodeRecordFilepathIsEmpty,
    QHVCNetErrorCodeRecordBasenameIsEmpty,
    QHVCNetErrorCodeExportRecordFileRangeNoLegal,
    QHVCNetErrorCodeExportRecordFileDestIsEmpty,
    QHVCNetErrorCodeExportRecordFileStatusIsEmpty = 535,
    QHVCNetErrorCodeCloudStorageDurationNoLegal,
    QHVCNetErrorCodeNoSupportedRecord,
    QHVCNetErrorCodeNoSupportedRecord2,
    QHVCNetErrorCodeRecord2InitConfigIsEmpty,
    QHVCNetErrorCodeRecord2InitConfigTotalSizeNoLegal = 540,
    QHVCNetErrorCodeRecord2FormatDiskDisksIsEmpty,
    QHVCNetErrorCodeRecord2FormatDiskNumNoLegal,
    QHVCNetErrorCodeRecord2FormatDiskNameIsEmpty,
    QHVCNetErrorCodeRecord2FormatDiskForceNoLegal,
    QHVCNetErrorCodeRecord2FormatDiskOnlyCallOnce = 545,
    QHVCNetErrorCodeRecord2FormatDiskFailed,
    QHVCNetErrorCodeNoSupportedCloudStorage,
    QHVCNetErrorCodeNoSupportedRelay,
    QHVCNetErrorCodeNoSupportedRtmp,
    QHVCNetErrorCodeNoSupportedAudioResample = 550,
    QHVCNetErrorCodeNoSupportedAudioAACEncoder,
    QHVCNetErrorCodeNoSupportedRTC,
    QHVCNetErrorCodeRTCExiting,
    QHVCNetErrorCodeActiveRTCing,
    QHVCNetErrorCodePassiveRTCing = 555,
    QHVCNetErrorCodeRTCSessionNotReady,
    QHVCNetErrorCodeCloudStorageRepeatStart,
    QHVCNetErrorCodeCloudStorageChangeInterval,
    QHVCNetErrorCodeCloudStorageChangeKey,
    QHVCNetErrorCodeNetDisconnect = 560,
    QHVCNetErrorCodeDeprecatedFunction,
    QHVCNetErrorCodeActiveRTCNotRunning,
    QHVCNetErrorCodeActiveRTCNotLogin,
    QHVCNetErrorCodeInputParamInvalid,
    
    //comm
    QHVCNetErrorCodeDeviceSerialNumberIsEmpty = 1000,
    QHVCNetErrorCodeClientIdIsEmpty,
    QHVCNetErrorCodeAppIdIsEmpty,
    QHVCNetErrorCodePlatformIdIsEmptyOnAppStart,
    QHVCNetErrorCodeVersionIsEmptyOnAppStart,
    QHVCNetErrorCodeOperatingSystemIsEmptyOnAppStart = 1005,
    QHVCNetErrorCodeMIDIsEmptyOnAppStart,
    QHVCNetErrorCodeModelIsEmptyOnAppStart,
    QHVCNetErrorCodeDeviceChannelNumNoLegal,
    QHVCNetErrorCodeNoSupportedBitrateType,
    QHVCNetErrorCodeNoSupportedPlayType = 1010,
    QHVCNetErrorCodeNoSupportedPlayMode,
    QHVCNetErrorCodeUserIdIsEmpty,
    QHVCNetErrorCodeChannelIdIsEmpty,
    QHVCNetErrorCodeUserSignIsEmpty,
    QHVCNetErrorCodeSecretKeyNumNoLegal = 1015,
    QHVCNetErrorCodeLongConnectTopicIsEmpty,
    QHVCNetErrorCodeLongConnectDataIsEmpty,
    QHVCNetErrorCodeLongConnectDataParseFailed,
    QHVCNetErrorCodeLongConnectDataUnknownModel,
    QHVCNetErrorCodeLongConnectDataNoFoundModel = 1020,
    QHVCNetErrorCodeLongConnectDataNoFoundData,
    QHVCNetErrorCodeNetSDKParseFailed,
    QHVCNetErrorCodeNetSDKUnknownType,
    QHVCNetErrorCodeNetSDKNoFoundContext,
    QHVCNetErrorCodeLongConnectNetSDKNoFoundResValueOfREQRelayRes = 1025,
    QHVCNetErrorCodeLongConnectNetSDKNoFoundTokenResOfREQRelayRes,
    QHVCNetErrorCodeLongConnectNetSDKUnknownFailed,
    QHVCNetErrorCodeNoSupportedLogLevel,
    QHVCNetErrorCodeLogPathIsEmpty,
    QHVCNetErrorCodeMediaDeviceHandleInvalid = 1030,
    QHVCNetErrorCodeParamIsEmpty,
    QHVCNetErrorCodeNoSupportedInnerLongConnect,
    QHVCNetErrorCodeFunctionCallOrderWrong,
    QHVCNetErrorCodeInvalidParam,
    QHVCNetErrorCodeVideoEncoderChanged = 1035,
    QHVCNetErrorCodeP2PMoreThanMax,
    QHVCNetErrorCodeSaveFileNoSupportedFormat,
    QHVCNetErrorCodeSaveFileCreateFileFailed,
    QHVCNetErrorCodeInvalidLicense,
    QHVCNetErrorCodeSaveFileNoMediaDataInTimeDuration = 1040,
    QHVCNetErrorCodeSaveFileUserStopSaveFile,
    QHVCNetErrorCodeFileDownloadNoFoundFile,
    
    //license鉴权
    QHVCNetErrorCodeAuthParamNonExistent = 100000,//认证串不存在
    QHVCNetErrorCodeAuthFormatError = 100001,//认证格式不正确
    QHVCNetErrorCodeAuthTimeNonExistent = 100002,//请求时间戳不存在
    QHVCNetErrorCodeAuthTimeFormatError = 100003,//请求时间戳格式不正确
    QHVCNetErrorCodeAuthRandomNonExistent = 100004,//随机数不存在
    QHVCNetErrorCodeAuthRandomFormatError = 100005,//随机数格式不正确
    QHVCNetErrorCodeAuthFailed = 100006,//认证失败
    QHVCNetErrorCodeAuthTimestampExpired = 110005,//请求时间戳过期或过大
    
    QHVCNetErrorCodeProductInvalid = 200002,//产品不存在
    QHVCNetErrorCodeProductStatusException = 200003,//产品状态异常
    QHVCNetErrorCodeDeviceInvalid = 400002,//设备不存在
    QHVCNetErrorCodeDeviceUnactivated = 400004,//设备未激活
    QHVCNetErrorCodeDeviceLicenseOverdue = 400005,//设备license已过期
    QHVCNetErrorCodeDeviceServiceOverdue = 400006,//设备云服务已过期
    QHVCNetErrorCodeDeviceServiceInvalid = 400008,//设备云服务不存在
    QHVCNetErrorCodeDeviceNotbound = 400009,//设备未绑定
    QHVCNetErrorCodeDeviceTokenFailed = 500000,//设备获取token失败
};

/**
 *  网络状态
 */
typedef NS_ENUM(NSInteger, QHVCNetNetworkStatus) {
    QHVCNetNetworkNotReachable = 0,
    QHVCNetNetworkReachableViaWiFi,
    QHVCNetNetworkReachableViaWWAN
};

/**
 * QHVCNetKit提供的服务类型
 */
typedef NS_OPTIONS(NSInteger, QHVCNetServiceType) {
    QHVCNetServicePrecache          =   1   <<  0,      // 预缓存服务
    QHVCNetServiceGodSees           =   1   <<  1       // 帝视服务
};

/**
 长连服务
 */
typedef NS_ENUM(NSInteger, QHVCNetLongConnectService) {
    QHVCNetLongConnectServiceSDKTracker = 1,//SDK自带Tracker长连
    QHVCNetLongConnectServiceExternal,//外部长连
};

/**
 网络连接类型
 */
typedef NS_ENUM(NSInteger, QHVCNetGodSeesNetworkConnectType) {
    QHVC_NET_GODSEES_NETWORK_CONNECT_TYPE_P2P              = 1,//p2p
    QHVC_NET_GODSEES_NETWORK_CONNECT_TYPE_RELAY            = (1<<1),//云端
    QHVC_NET_GODSEES_NETWORK_CONNECT_TYPE_DIRECT_IP        = (1<<2),//IP直连
};

/**
 网络模式
 */
typedef NS_ENUM(NSInteger, QHVCNetGodSeesNetworkMode) {
    QHVC_NET_GODSEES_NETWORK_MODE_LAN            = 1,//局域网
    QHVC_NET_GODSEES_NETWORK_MODE_WAN            = (1<<1),//广域网
};
/*
 设备平台
 */
typedef NS_ENUM(NSInteger, QHVCNetGodSeesDevicePlatformType) {
    QHVC_NET_GODSEES_DEVICE_PLATFORM_NORMAL    = 1,
    QHVC_NET_GODSEES_DEVICE_PLATFORM_OLD,
};

/**
 会话类型
 */
typedef NS_ENUM(NSInteger, QHVCNetGodSeesSessionType) {
    QHVC_NET_GODSEES_SESSION_TYPE_LIVE = 1,  //直播
    QHVC_NET_GODSEES_SESSION_TYPE_RECORD,    //回放
    QHVC_NET_GODSEES_SESSION_TYPE_FILE_DOWNLOAD, //文件下载
};

/**
 码流类型
 码流大小根据硬件设备性能自定义
 */
typedef NS_ENUM(NSInteger, QHVCNetGodSeesStreamType) {
    QHVC_NET_GODSEES_STREAM_TYPE_MAIN = 1,  // 主码流
    QHVC_NET_GODSEES_STREAM_TYPE_SUB,       // 子码流
    QHVC_NET_GODSEES_STREAM_TYPE_THIRD,     // 第三码流
};

/**
 数据帧类型
 */
typedef NS_ENUM(NSInteger, QHVCNetGodSeesFrameDataType) {
    QHVC_NET_GODSEES_FRAME_DATA_TYPE_NONE = 0,
    QHVC_NET_GODSEES_FRAME_DATA_TYPE_H264,
    QHVC_NET_GODSEES_FRAME_DATA_TYPE_H265,
    QHVC_NET_GODSEES_FRAME_DATA_TYPE_AAC,
    QHVC_NET_GODSEES_FRAME_DATA_TYPE_OPUS,
    QHVC_NET_GODSEES_FRAME_DATA_TYPE_PCM_S16LE,
    QHVC_NET_GODSEES_FRAME_DATA_TYPE_PCM_MULAW,
    QHVC_NET_GODSEES_FRAME_DATA_TYPE_PCM_ALAW,
    QHVC_NET_GODSEES_FRAME_DATA_TYPE_G726,
    QHVC_NET_GODSEES_FRAME_DATA_TYPE_MJPEG,
};

/**
 解密规则
 */
typedef NS_ENUM(NSInteger, QHVCNetGodSeesDecryptionRules) {
    QHVC_NET_GODSEES_DECRYPTION_RULES_NONE = 0,   //无密
    QHVC_NET_GODSEES_DECRYPTION_RULES_XOR = 1,    //XOR方式
    QHVC_NET_GODSEES_DECRYPTION_RULES_RC4,        //RC4方式
};

/**
rtc session状态
*/
typedef NS_ENUM(NSInteger, QHVCNetGodSeesRTCSessionStatus) {
    QHVC_NET_GODSEES_RTC_SESSION_SUCCESS = 1,         //成功建立rtc session
    QHVC_NET_GODSEES_RTC_SESSION_BE_USED,             //固件rtc session已经被其它APP占用
    QHVC_NET_GODSEES_RTC_SESSION_REJECT,              //固件拒绝rtc session
    QHVC_NET_GODSEES_RTC_SESSION_TIMEOUT,             //rtc session timeout
    QHVC_NET_GODSEES_RTC_SESSION_NO_SUPPORT_SPY_RTC,  //不支持自研rtc
    QHVC_NET_GODSEES_RTC_SESSION_UNKNOWN_RES = 50,    //未知的响应
};

/**
 文件下载状态
 */
typedef NS_ENUM(NSInteger, QHVCNetGodSeesDownloadStatus) {
    QHVC_NET_GODSEES_DOWNLOAD_ING = 1,//下载中
    QHVC_NET_GODSEES_DOWNLOAD_PAUSE,//暂停下载
    QHVC_NET_GODSEES_DOWNLOAD_SUCCESS,//下载完毕
};

/**
 设备工作模式
 */
typedef NS_ENUM(NSInteger, QHVCNetGodSeesDeviceWorkMode) {
    QHVC_NET_GODSEES_LONG_POWER_LIVE = 1,//长带电设备
    QHVC_NET_GODSEES_LOW_POWER_WAKEUP,//低功耗唤醒设备
};

/**
 设备双工通话模式
 */
typedef NS_ENUM(NSInteger, QHVCNetGodSeesDeviceDuplexMode) {
    QHVC_NET_GODSEES_DUPLEX_MODE_HALF = 1,//半双工通话模式
    QHVC_NET_GODSEES_DUPLEX_MODE_FULL = 2,//全双工通话模式
};

#endif /* QHVCNetEnumerates_h */
